
  <!DOCTYPE html>
  <html>
    <head>
      <title>projectSettings.ts</title>
      <link href="https://cdn.jsdelivr.net/npm/semantic-ui@2.4.2/dist/semantic.min.css" type="text/css" rel="stylesheet">
      <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.js" type="text/javascript" charset="utf-8"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/mode/javascript/javascript.min.js" type="text/javascript" charset="utf-8"></script>
<link href="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.css" type="text/css" rel="stylesheet">
<script src="../../../assets/source-file.js" type="text/javascript" charset="utf-8"></script>
<link href="../../../assets/source-file.css" type="text/css" rel="stylesheet">
    </head>
    <body>
    <div style="margin-top:3em" class="ui container"><h1 class="ui header"><a href="../../../index.html">TypeScript coverage report</a></h1><table style="margin-top:2em" class="ui celled table"><thead class=""><tr class=""><th class="">Filename</th><th class="">Percent</th><th class="">Threshold</th><th class="">Total</th><th class="">Covered</th><th class="">Uncovered</th></tr></thead><tbody class=""><tr class="positive"><td class="">src/api/projectSettings.ts</td><td class="">96.97%</td><td class="">80%</td><td class="">198</td><td class="">192</td><td class="">6</td></tr></tbody></table><textarea id="editor" readonly="" style="margin-top:3em">import { get, patch, post } from &#x27;./methods&#x27;;
import {
  createErrorNotification,
  createInfoNotification,
  NOTY_TIMEOUT
} from &#x27;../components/notifications&#x27;;

export const mapOutputTypeToInputType = {
  &#x27;Inhibitor factor&#x27;: &#x27;INHIBITOR_FACTOR&#x27;,
  &#x27;Substrate factor&#x27;: &#x27;SUBSTRATE_FACTOR&#x27;,
  &#x27;Quadratic factor&#x27;: &#x27;QUADRATIC_FACTOR&#x27;
};

export const mapOutputRoleToInputRole = {
  &#x27;Growth parameter&#x27;: &#x27;GROWTH_PARAMETER&#x27;,
  Independent: &#x27;INDEPENDENT&#x27;,
  Metabolite: &#x27;METABOLITE&#x27;,
  &#x27;Built-in&#x27;: &#x27;BUILT_IN&#x27;
};
export type FitParameter = {
  name: string;
  role: &#x27;GROWTH_PARAMETER&#x27; | &#x27;Independent&#x27; | &#x27;Metabolite&#x27; | &#x27;BUILT_IN&#x27;;

  type?: &#x27;INHIBITOR_FACTOR&#x27; | &#x27;SUBSTRATE_FACTOR&#x27; | &#x27;QUADRATIC_FACTOR&#x27;;
  upper_bound?: number;
  lower_bound?: number;
  target?: number;
  spread?: {
    lower_bound: number;
    upper_bound: number;
  };
  threshold?: {
    lower_bound: number;
    upper_bound: number;
  };
};

export type FitProcedure = {
  step_name: &#x27;Exploration&#x27; | &#x27;Refinement&#x27;;
  number_of_particles: number;
  iterations: number;
};

export type ProjectSettings = {
  fed_batch_call_density: number;
  fed_batch_viability: number;
  perfusion_bleed: number;
  perfusion_viability: number;
  objective_penalty: &#x27;SQUARED_ERROR&#x27; | &#x27;AUTO_CORRELATION&#x27;;
  date_type: &#x27;DAYS&#x27; | &#x27;HOURS&#x27;;
  viable_cell_density_type: &#x27;NORMAL&#x27; | &#x27;E_SIX&#x27; | &#x27;E_FIVE&#x27;;
  bleed_controller_gain: number;
  bleed_controller_rest_time: number;
  max_oxygen_rate: number;
  perfusion_rate_threshold: number;
  source_of_toxicity: &#x27;LYSED_CELLS&#x27; | &#x27;BIOMATERIAL&#x27;;
  source_of_inhibition: &#x27;LYSED_CELLS&#x27; | &#x27;BIOMATERIAL&#x27;;
};

export type GetQueryProjectSettings = {
  fed_batch_call_density: number;
  fed_batch_viability: number;
  perfusion_bleed: number;
  perfusion_viability: number;
  objective_penalty: &#x27;SQUARED&#x27; | &#x27;SSE&#x27;;
  date_type: &#x27;Days&#x27; | &#x27;Hours&#x27;;
  viable_cell_density_type: &#x27;cells/ml&#x27; | &#x27;1e6 cells/ml&#x27; | &#x27;1e5 cells/ml&#x27;;
  bleed_controller_gain: number;
  bleed_controller_rest_time: number;
  max_oxygen_rate: number;
  perfusion_rate_threshold: number;
  source_of_toxicity: &#x27;Lysed cells&#x27; | &#x27;Biomaterial&#x27;;
  source_of_inhibition: &#x27;Lysed cells&#x27; | &#x27;Biomaterial&#x27;;
};

export class ProjectSettingsApi {
  static getById = async (projectId: string | number) =&gt; {
    try {
      const projectSettings = await get&lt;
        GetQueryProjectSettings &amp; { id: string }
      &gt;(`project/${projectId}/project-settings`);
      const fitProcedures = await get&lt;(FitProcedure &amp; { id: string })[]&gt;(
        `projects/${projectId}/fit-procedures`
      );
      const fitParameters = await get&lt;(FitParameter &amp; { id: string })[]&gt;(
        `projects/${projectId}/fit-parameters`
      );
      return {
        projectSettings,
        fitProcedures,
        fitParameters
      };
    } catch (e: any) {
      createErrorNotification({
        text: &#x27;An error occurred while getting the project parameters&#x27;,
        timeout: NOTY_TIMEOUT
      });
      throw e;
    }
  };

  static create = async (
    projectId: string | number,
    {
      projectSettings,
      fitParameters,
      fitProcedures
    }: {
      projectSettings: ProjectSettings;
      fitProcedures: FitProcedure[];
      fitParameters: FitParameter[];
    }
  ) =&gt; {
    const createProjectSettingsNoty = createInfoNotification({
      text: &#x27;The project settings are being created&#x27;
    });
    createProjectSettingsNoty.show();
    return Promise.all([
      post(&#x27;project/project-settings&#x27;, {
        ...projectSettings,
        project_id: projectId
      }),
      post(
        &#x27;fit-procedures&#x27;,
        fitProcedures.map((procedure) =&gt; ({ ...procedure, project: projectId }))
      ),
      post(
        &#x27;fit-parameters&#x27;,
        fitParameters.map((param) =&gt; ({ ...param, project: projectId }))
      )
    ])
      .catch((e: any) =&gt; {
        createErrorNotification({
          text: &#x27;An error occurred when creating the project settings&#x27;,
          timeout: NOTY_TIMEOUT
        }).show();
        throw e;
      })
      .finally(() =&gt; {
        setTimeout(() =&gt; {
          createProjectSettingsNoty.close();
        }, NOTY_TIMEOUT / 2);
      });
  };

  static update = async ({
    projectId,
    projectSettings,
    fitParameters,
    fitProcedures
  }: {
    projectId: string;
    fitParameters: (FitParameter &amp; { id: string })[];
    fitProcedures: (FitProcedure &amp; { id: string })[];
    projectSettings: ProjectSettings &amp; { id: string };
  }) =&gt; {
    const updateProjectSettingsNoty = createInfoNotification({
      text: &#x27;The project settings are being created&#x27;
    });
    updateProjectSettingsNoty.show();
    return Promise.all([
      patch(`project/${projectId}/project-settings`, {
        project_id: projectId,
        ...projectSettings
      }),
      patch(
        &#x27;fit-parameters&#x27;,
        fitParameters.map((param) =&gt; ({ ...param, project: projectId }))
      ),
      patch(
        &#x27;fit-procedures&#x27;,
        fitProcedures.map((procedure) =&gt; ({ ...procedure, project: projectId }))
      )
    ])
      .catch((e: any) =&gt; {
        createErrorNotification({
          text: &#x27;An error occurred when creating the project settings&#x27;,
          timeout: NOTY_TIMEOUT
        }).show();
        throw e;
      })
      .finally(() =&gt; {
        setTimeout(() =&gt; {
          updateProjectSettingsNoty.close();
        }, NOTY_TIMEOUT / 2);
      });
  };

  static updateFitParameters = (
    projectId: string,
    fitParameters: (Partial&lt;FitParameter&gt; &amp; { id: string })[]
  ) =&gt;
    patch(
      &#x27;fit-parameters&#x27;,
      fitParameters.map((param) =&gt; ({ ...param, project: projectId }))
    );
}
</textarea><pre id="annotations" style="display:none">[{&quot;file&quot;:&quot;src/api/projectSettings.ts&quot;,&quot;line&quot;:97,&quot;character&quot;:12,&quot;text&quot;:&quot;e&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/api/projectSettings.ts&quot;,&quot;line&quot;:92,&quot;character&quot;:13,&quot;text&quot;:&quot;e&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/api/projectSettings.ts&quot;,&quot;line&quot;:131,&quot;character&quot;:14,&quot;text&quot;:&quot;e&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/api/projectSettings.ts&quot;,&quot;line&quot;:136,&quot;character&quot;:14,&quot;text&quot;:&quot;e&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/api/projectSettings.ts&quot;,&quot;line&quot;:174,&quot;character&quot;:14,&quot;text&quot;:&quot;e&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/api/projectSettings.ts&quot;,&quot;line&quot;:179,&quot;character&quot;:14,&quot;text&quot;:&quot;e&quot;,&quot;kind&quot;:1}]</pre></div>
    <p class="footer-text">TypeScript Coverage Report generated by <a href="https://github.com/plantain-00/type-coverage">type-coverage</a> and <a href="https://github.com/alexcanessa/typescript-coverage-report">typescript-coverage-report</a> at Tue, 05 Oct 2021 23:09:04 GMT</p>
    </body>
  </html>
  